% Script to test the MSDM mex library on a series of distorted bunnies
% with random noise addition.
load('bunny');
length_bbox = sqrt(sum((min(V) - max(V)).^2));
ref_length = 0.5 * length_bbox;
noise_amplitudes = 0.01 * logspace(-5, 1.3, 70);
dist = zeros(length(noise_amplitudes), 1);
for ii = 1 : length(noise_amplitudes)
	amplitudes_max = noise_amplitudes(ii) * ref_length;
    noise_direction = -0.5 + rand(size(V));
    noise_direction = bsxfun(@rdivide, noise_direction, ...
        sqrt(sum(noise_direction.^2, 2))); 
    amplitudes = amplitudes_max * (-0.5 + rand(size(V,1), 1));
    V_noise = V + bsxfun(@times, amplitudes(:), noise_direction);
    dist(ii) = mCGAL_MSDM(V, F, V_noise, F);
end

figure;
semilogx(noise_amplitudes, dist);
xlabel('noise addition strength');
ylabel('MSDM');
